#ifndef FTPD_H
#define FTPD_H
#ifdef __cplusplus
extern "C" {
#endif 

#include <pkgconf/net_ftpserver.h>
#include <limits.h>
#include "cyg/kernel/kapi.h"

typedef int (*check_password_t)(const char *, const char *); /* 0 for OK, non-null for error */

typedef struct ftp_server {
	/* Configurable part, memset to 0 and then configure */
	unsigned int port;

	unsigned int max_nr_of_clients;
	unsigned int nr_of_clients;
	unsigned int allow_guest;
	unsigned int firstport;	/* first and last ports to use, if we're */
	unsigned int lastport;	/* packet filter friendly. */

	check_password_t check_pwd;

	char chrootdir[PATH_MAX + 1];	/* root of the visible filesystem */

	int thread_prio; /* Thread priority */

	/* Internal data, don't touch */
	cyg_mutex_t mutex;
	struct ftp_session *active_sessions;
	volatile int stopping;
	volatile int running;

} ftp_server_t;


int ftpd_server( ftp_server_t * );
int ftpd_server_stop ( ftp_server_t * );

#ifdef __cplusplus
}
#endif 
#endif
